﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using HeuristicLab.Common;
using HeuristicLab.Persistence;

namespace HeuristicLab.Core {
  [StorableType("bb99e419-45fb-4c73-bf76-e4a37b154ca6")]
  public interface IArc : IItem {
    IVertex Source { get; }
    IVertex Target { get; }
    string Label { get; set; }
    double Weight { get; set; }

    event EventHandler Changed; // generic event for when the label, weight or data were changed
  }

  [StorableType("ae2ee002-878b-4fd4-8ef4-0a97397bf1dd")]
  public interface IArc<T> : IArc where T : class, IDeepCloneable {
    T Data { get; set; }
  }
}